"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = __importDefault(require("./base"));
exports.messages = {
    'boolean.typeof': (name) => `${name} must be a valid boolean`,
    'boolean.true': (name) => `${name} must be true`,
    'boolean.false': (name) => `${name} must be false`,
};
/**
 * Boolean class
 */
class TypeBoolean extends base_1.default {
    /**
     * Constructor
     */
    constructor() {
        super();
        this.name = 'boolean';
        this.typeof();
    }
    /**
     * Try to cast value
     *
     * @param {mixed} value
     * @return {boolean|mixed}
     */
    _cast(value) {
        if (typeof value === 'string') {
            if (value === 'true' || value === 'True') {
                return true;
            }
            else if (value === 'false' || value === 'False') {
                return false;
            }
        }
        return value;
    }
    /**
     * Test to validate the type of the value
     *
     * @return {this}
     */
    typeof() {
        this.test('typeof', (str) => {
            return typeof str === 'boolean';
        });
        return this;
    }
    /**
     * Force a boolean to equal true
     *
     * @return {this}
     */
    true() {
        this.test('true', (str) => {
            return str === true;
        });
        return this;
    }
    /**
     * Force a boolean to equal false
     *
     * @return {this}
     */
    false() {
        this.test('false', (str) => {
            return str === false;
        });
        return this;
    }
}
exports.TypeBoolean = TypeBoolean;
const def = {
    Class: TypeBoolean,
    messages: exports.messages,
};
exports.default = def;
